#include "stdafx.h"
#include "wmf.h"
#include "POOM.h"
#include <algorithm>

Strings CheckExistFolders(MAPI::CSession &Session, CIniFile &ini);
BOOL AddFilterAddress(CIniFile &ini, const std::wstring &SectionName, IContact *pContact);
BOOL AddFilterFolder(CIniFile &ini, POOM::CApp &poom, const std::wstring &Condition, const std::wstring &SectionName);
BOOL AddFilterFolderByName(CIniFile &ini, MAPI::CFolder &folder, POOM::CApp &poom);
BOOL AddFilterFolderByCategories(CIniFile &ini, MAPI::CFolder &folder, POOM::CApp &poom);
BOOL CheckFilterFolderByCategories(CIniFile &ini, const std::wstring &CategoryName, MAPI::CFolder &folder, POOM::CApp &poom);
Strings &AddFilterFolders(MAPI::CSession &Session, CIniFile &ini, Strings &NowFolders);

/**
 * ftHg̐ݒ
 */
void SetDefaultIniData(CIniFile &ini, MAPI::CSession &Session)
{
	ini.SetIntValue(_T("setting"), _T("alreadyreadonly"), 1, TRUE);

	MAPI::CMsgStore &msgStore = Session.GetPdxAccount();
	std::wstring accountName = msgStore.GetDisplayName();

	std::wstring baseFolder = accountName + _T("\\U蕪");
	ini.SetValue(_T("setting"), _T("basefolder"), baseFolder, TRUE);
	ini.SetIntValue(_T("setting"), _T("auto"), 1, TRUE);	

	MAPI::CFolder &inbox = msgStore.GetInboxFolder();
	std::wstring openFolder = inbox.GetPath();
	openFolder += _T("\\Mς݃ACe");
	ini.SetValue(_T("setting"), _T("openfolder"), openFolder, TRUE);
	ini.SetValue(_T("setting"), _T("openfolderwhenempty"), openFolder, TRUE);

	ini.SetIntValue(_T("setting"), _T("openlastfilterfolder"), 0, TRUE);
	ini.SetIntValue(_T("setting"), _T("shownoread"), 0, TRUE);
	ini.SetIntValue(_T("setting"), _T("showdir"), 0, TRUE);

	//tB^Ώۂ̏l
	MAPI::CFolder &folder = Session.GetPdxRecievedFolder();
	ini.SetValue(_T("target"), _T("folder"), folder.GetPath(), TRUE);
}

/**
 * tB^ݒsAtB^Ώۂԋp
 */
Strings SetFilterSetting(MAPI::CSession &Session, CIniFile &ini)
{
	//̏擾
	Strings results = CheckExistFolders(Session, ini);

	//VT
	if (ini.GetIntValue(_T("setting"), _T("auto"))) {
		results = AddFilterFolders(Session, ini, results);
	}

	return results;
}


/**
 * ɐݒ肳ĂtH_܂݂邩mFA
 * ݂Ȃݒ폜B
 */
Strings CheckExistFolders(MAPI::CSession &Session, CIniFile &ini)
{
	Sections &Sections = ini.GetSections();
	Sections::iterator it;
	Strings folders;

	//ɐݒ肳ĂtH_܂݂邩mF
	it = Sections.begin();
	while (it != Sections.end()) {
		std::wstring FolderName = it->first;
		if (FolderName == _T("setting") || FolderName == _T("target")) {
			it++;
			continue;
		}

		try {
			MAPI::CFolder &folder = Session.GetFolder(FolderName);
			folders.push_back(folder.GetPath());
			it++;
		} catch (wchar_t *) {
			WCHAR msg[512];
			wsprintf(msg, _T("%s\nLtH_͌ݑ݂Ȃ悤łB\nݒ肩폜܂H"), FolderName.c_str());
			int result = MessageBox(GetForegroundWindow(), msg, _T("mF"), MB_OKCANCEL);
			switch (result) {
				case IDOK:
					it = Sections.erase(it);
					break;
				case IDCANCEL:
					throw _T("𒆒f܂B");
					break;
			}
		}
	}

	return folders;
}

/**
 * IContact胁[AhXiniɒǉB
 */
BOOL AddFilterAddress(CIniFile &ini, const std::wstring &SectionName, IContact *pContact)
{
	BOOL result = FALSE;
	HRESULT hr = S_OK;
	BSTR pwszBuff = NULL;
	hr = pContact->get_Email1Address(&pwszBuff);
	if (SUCCEEDED(hr)) {
		if (wcslen(pwszBuff) > 0) {
			ini.AddValue(SectionName, _T("pattern"), std::wstring(_T("1:")) + pwszBuff);
			result = TRUE;
		}
		SysFreeString(pwszBuff);
	}
	hr = pContact->get_Email2Address(&pwszBuff);
	if (SUCCEEDED(hr)) {
		if (wcslen(pwszBuff) > 0) {
			ini.AddValue(SectionName, _T("pattern"), std::wstring(_T("1:")) + pwszBuff);
			result = TRUE;
		}
		SysFreeString(pwszBuff);
	}
	hr = pContact->get_Email3Address(&pwszBuff);
	if (SUCCEEDED(hr)) {
		if (wcslen(pwszBuff) > 0) {
			ini.AddValue(SectionName, _T("pattern"), std::wstring(_T("1:")) + pwszBuff);
			result = TRUE;
		}
		SysFreeString(pwszBuff);
	}

	return result;
}

/**
 * A悩ɊY郁[AhXāAݒɒǉ
 */
BOOL AddFilterFolder(CIniFile &ini, POOM::CApp &poom, const std::wstring &Condition, const std::wstring &SectionName)
{
	BOOL result = FALSE;

	IContact *pContact = NULL;
	IPOutlookItemCollection *pItems = poom.GetContacts();
	HRESULT hr = pItems->Find((BSTR) Condition.c_str(), (IDispatch **) &pContact);

	while (SUCCEEDED(hr) && pContact != NULL) {
		if (AddFilterAddress(ini, SectionName, pContact)) {
			result = TRUE;
		}

		pContact->Release();
		pContact = NULL;
		hr = pItems->FindNext((IDispatch **) &pContact);
	}

	return result;
}

/**
 * A悩Y郁[AhXāAݒɒǉ
 */
BOOL AddFilterFolderByName(CIniFile &ini, MAPI::CFolder &folder, POOM::CApp &poom)
{
	std::wstring FolderName = folder.GetDisplayName();

	//쐬
	//name󔒕ŋ؂ĂAFirstNameLastNameƂĕB
	//łȂFirstNameLastNamêꂩAƂɂB
	std::wstring cond = _T("");
	std::wstring::size_type pos = FolderName.find(_T(" "));
	if (pos == std::wstring::npos) {
		pos = FolderName.find(_T("@"));
	}
	if (pos != std::wstring::npos) {
		cond = _T("([LastName] = \"") + FolderName.substr(0, pos) + _T("\"")
			 + _T(" AND ")
			 + _T("[FirstName] = \"") + FolderName.substr(pos + 1) + _T("\")")
			 + _T(" OR ");
	}
	cond += _T("[FirstName] = \"") + FolderName + _T("\"")
		 + _T(" OR ")
		 + _T("[LastName] = \"") + FolderName + _T("\"");

	//s
	BOOL result = AddFilterFolder(ini, poom, cond, folder.GetPath());
	if (result) {
		WCHAR msg[256];
		wsprintf(msg, _T("%s\nւ̐U蕪ǉ܂B"), folder.GetPath().c_str());
		MessageBox(GetForegroundWindow(), msg, _T("mF"), MB_OK);
	}
	return result;
}

/**
 * ÁuލځvY郁[AhXāAݒɒǉ
 */
BOOL AddFilterFolderByCategories(CIniFile &ini, MAPI::CFolder &folder, POOM::CApp &poom)
{
	std::wstring FolderName = folder.GetDisplayName();

	//쐬
	std::wstring cond = _T("[Categories] = \"") + FolderName + _T("\"");

	//s
	BOOL result = AddFilterFolder(ini, poom, cond, folder.GetPath());
	if (result) {
		ini.SetIntValue(folder.GetPath(), _T("iscategories"), 1);
		ini.SetValue(folder.GetPath(), _T("categoryname"), FolderName);

		WCHAR msg[256];
		wsprintf(msg,
			_T("%s\nւ̐U蕪\nލ:%s\nƂĒǉ܂B\n\nӁF̐ݒ͖A悩ēǂݍ݂܂Bēǂݍ݂~߂ꍇiscategories=0ɐݒ肵ĂB"),
			folder.GetPath().c_str(),
			FolderName.c_str());
		MessageBox(GetForegroundWindow(), msg, _T("mF"), MB_OK);
	}
	return result;
}

/**
 * ÁuލځvY郁[AhXāAݒύX
 */
BOOL CheckFilterFolderByCategories(CIniFile &ini, const std::wstring &CategoryName, MAPI::CFolder &folder, POOM::CApp &poom)
{
	//쐬
	std::wstring cond = _T("[Categories] = \"") + CategoryName + _T("\"");

	//܂ł̐ݒ폜
	ini.DeleteValues(folder.GetPath());

	//s
	BOOL result = AddFilterFolder(ini, poom, cond, folder.GetPath());
	if (result) {
		ini.SetIntValue(folder.GetPath(), _T("iscategories"), 1);
		ini.SetValue(folder.GetPath(), _T("categoryname"), CategoryName);
	}
	return result;
}

/**
 * VtH_basefolderɑĂȂmFA
 * ĂΐݒɒǉB
 * tB^ΏۃXgԂB
 */
Strings &AddFilterFolders(MAPI::CSession &Session, CIniFile &ini, Strings &NowFolders)
{
	MAPI::CFolder *pBase;
	std::wstring &baseFolder = ini.GetValue(_T("setting"), _T("basefolder"));
	try {
		pBase = &(Session.GetFolder(baseFolder));
	} catch (wchar_t *) {
		//x[XtH_Ȃ΁Aȍ~̏͂ȂB
		WCHAR msg[512];
		wsprintf(msg,
			_T("x[XtH_\n%s\n܂łB\n\nU蕪̎擾͍s܂Bݒt@CύX邩A̓x[XtH_쐬čĎsĂB"),
			baseFolder.c_str());
		MessageBox(GetForegroundWindow(), msg, _T("mF"), MB_OK);
		return NowFolders;
	}
	MAPI::CFolders &sub = pBase->GetSubFolders();
	POOM::CApp poom;
	MAPI::CFolders::iterator it;
	for (it = sub.begin(); it != sub.end(); it++) {
		if (std::find(NowFolders.begin(), NowFolders.end(), (*it)->GetPath()) != NowFolders.end()) {
			//uލځvptH_ȂAXV`FbN
			if (ini.GetIntValue((*it)->GetPath(), _T("iscategories"), 0, FALSE)) {
				std::wstring categoryName =
					ini.GetValue((*it)->GetPath(), _T("categoryname"), (*it)->GetDisplayName());
				CheckFilterFolderByCategories(ini, categoryName, **it, poom);
			}
		} else {
			//tH_ɊYuލځv邩`FbNA
			//΃tB^ΏۃXgɒǉB
			if (AddFilterFolderByCategories(ini, **it, poom)) {
				NowFolders.push_back((*it)->GetPath());

			//tH_ɊYuOv邩`FbNA
			//΃tB^ΏۃXgɒǉB
			} else if (AddFilterFolderByName(ini, **it, poom)) {
				NowFolders.push_back((*it)->GetPath());
			}
		}
	}

	return NowFolders;
}
